AchievementsColoredLibrary = AchievementsColoredLibrary or {}
local ACL = AchievementsColoredLibrary
ACL = {
	name	= "AchievementsColoredLibrary",
	author	= "tim99",
	version	= 1,
	c_red	= ZO_ColorDef:New("ff6666"),
	c_grn	= ZO_ColorDef:New("66ff66"),
}
---------------------------------------------------------------------------------------------------------
function ACL:GetTextColor()
	local b,c,d,e=self.normalColor:UnpackRGBA()
	if self.selected then return b,c,d,0.4 elseif self.mouseover then return b,c,d,0.7 end
	return b,c,d,e 
end
---------------------------------------------------------------------------------------------------------
function ACL.AchievementSetupFunction(node, control, data, open, userRequested, enabled)
	ACL.oldSetupFunction(node, control, data, open, userRequested, enabled)
	-- >>> Farbe berechnen
	local numAch, subEarned, subTotal
	local parentData = data.parentData
	if not data.isFakedSubcategory and parentData then
		numAch, subEarned, subTotal = select(2, GetAchievementSubCategoryInfo(parentData.categoryIndex, data.categoryIndex))
	else
		local numSubCat,numAchie, earnedPnt, totalPnt, hidesP = select(2, GetAchievementCategoryInfo(data.categoryIndex))
		if parentData then
			for subCatIndex = 1, numSubCat do
				local subCatEarned, subCatTotal = select(3, GetAchievementSubCategoryInfo(parentData.categoryIndex, subCatIndex))
				earnedPnt = earnedPnt - subCatEarned
				totalPnt = totalPnt - subCatTotal
			end
		end
		subEarned = earnedPnt
		subTotal = totalPnt
	end
	local col = (subEarned == subTotal) and ACL.c_grn or ACL.c_red
	-- Farbe berechnen <<<
	ZO_SelectableLabel_SetNormalColor(control, col)
	if control.GetTextColor ~= ACL.GetTextColor then control.GetTextColor = ACL.GetTextColor end
	control:RefreshTextColor()
	local oldTxt = control:GetText()
	local newTxt = ZO_NORMAL_TEXT:Colorize(string.format("%s/%s", subEarned, subTotal))
	control:SetText(string.format("%s %s|r", tostring(oldTxt), tostring(newTxt)))
end
---------------------------------------------------------------------------------------------------------
local function sceneChange(oldState, newState)
    if newState == SCENE_SHOWN then
		if ACL.oldSetupFunction==nil then
			ACL.oldSetupFunction=ACHIEVEMENTS.categoryTree.templateInfo.ZO_TreeLabelSubCategory.setupFunction
			ACHIEVEMENTS.categoryTree.templateInfo.ZO_TreeLabelSubCategory.setupFunction = ACL.AchievementSetupFunction
			ACHIEVEMENTS.refreshGroups:RefreshAll("FullUpdate")
		end
    end
end
---------------------------------------------------------------------------------------------------------
function ACL.addonLoaded(event, addonName)
	if addonName ~= ACL.name then return end
	EVENT_MANAGER:UnregisterForEvent(ACL.name, EVENT_ADD_ON_LOADED)
	SCENE_MANAGER:GetScene("achievements"):RegisterCallback("StateChange", sceneChange)
end
---------------------------------------------------------------------------------------------------------
EVENT_MANAGER:RegisterForEvent(ACL.name, EVENT_ADD_ON_LOADED, ACL.addonLoaded)
